#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++


class DatosAgenteController < ApplicationController

 # --
 ########## ETAPAS ##########
 # ++
	# en agentes: se redirecciona por defecto a etapas
  def index
    redirect_to :action => 'etapas'  
  end

  # en agentes: lista las etapas relacionadas
  def etapas
    @etapas = @agente.etapa
    render "comunes/etapas"
  end

  #  en agentes: crea una nueva etapa con un tipo determinado según la sección.
  def editar_nuevo_etapa
    @etapa = params[:id] ?  Etapa.find(params[:id]) : nil
    render :partial => "comunes/etapa"
  end

	#  en agentes: modifica o crea un determinada etapa
  def modificar_crear_etapa
    @etapa = params[:id] ?  Etapa.find(params[:id]) : Etapa.new(:agente_id => @agente.id)
    @etapa.update_attributes params[:etapa]
    flash[:error] = @etapa
    redirect_to :action => 'etapas'
  end

	#  en agentes: elimina etapa.
  def eliminar_etapa
    @etapa = Etapa.find(params[:id])
    @etapa.destroy
    flash[:error_eliminar] = @etapa
    redirect_to :action => 'etapas'
  end

end
#done

