#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de la gestión de los pagos.
# Este controlador es utilizado desde las secciones:
# * Sección proyectos: se utiliza para listar, asignar y desasignar pagos a gastos 
# * Sección agentes: se utiliza para listar, asignar y desasignar pagos a gastos 
class PagoController < ApplicationController

  # --
  # METODOS AJAX DE PAGOS
  # --

  def pagos
    @pagos = Gasto.find(params[:gasto_id]).pago
    render :update do |page|
      page.replace_html params[:update], :partial => "listado"
    end
  end

  def anadir_pago
    @pago = params[:id] ?  Pago.find(params[:id]) : Pago.new
    gasto = Gasto.find(params[:gasto_id])
    @pago.gasto = gasto
    pagopendiente = gasto.importe
    gasto.pago.each { |pago| pagopendiente -= pago.importe }
    pagofecha = Time.now.to_s
    render :partial => "formulario", :update => params[:update], :locals => {:pagopendiente => pagopendiente.to_s}
  end

  def modificar_crear_pago
    @pago = params[:id] ? Pago.find(params[:id]) : Pago.new
    @pago.update_attributes params[:pago]
    @pagos = Gasto.find(@pago.gasto_id).pago
    render :update do |page|
      page.replace_html params[:update], :partial => "listado"
      page.visual_effect :highlight, params[:update] , :duration => 6
      page.replace 'formulario', :inline => '<%= mensaje_error(@pago) %><br>'
      page.call("Modalbox.resizeToContent")
    end
  end

  def eliminar_pago
    @pago = Pago.find(params[:id])
    @pago.destroy
    @pagos = Gasto.find(params[:gasto_id]).pago
    render :update do |page|
      page.replace_html params[:update], :partial => "listado"
      page.visual_effect :highlight, params[:update] , :duration => 6
      page.replace_html 'MB_content', :inline => '<%= mensaje_error(@pago, :eliminar => true) %><br>'
      page.call("Modalbox.resizeToContent")
    end
  end

end
