#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de las vistas resumen financieras para una agente implementador. Este controlador es utilizado desde las secciones agentes.

class ResumenAgenteController < ApplicationController

  helper :resumen_proyecto
  
  # en agente: se redirecciona por defecto a presupuesto
  def index
      if @agente.etapa.empty? 
        flash[:error] = _("Tiene que definir por lo menos una etapa")
        redirect_to :controller => :datos_agente, :action => :etapas
      else
        redirect_to :action => :presupuesto
      end
  end

  def gasto
     @listado_moneda = Moneda.find(:all).collect{|e| [e.nombre, e.id]}
    # Hacemos la busqueda si se seleccionan los criterios
    estado_gasto if params[:moneda]
  end

  def estado_gasto
    @fecha_de_inicio = fecha params["fecha_inicio"]
    @fecha_de_fin = fecha params["fecha_fin"]
    @filas = Partida.find(:all, :order => "codigo").collect{|i| {"id" => i.id, "nombre" => i.codigo_nombre}}
    @columnas = [{"id" => "1", "nombre" => "Presupuesto"}, {"id" => "2", "nombre" => "Gastos"}]
    presupuestos = VPresupuestoDetallado.partida_de_implementador_sin_proyecto(params[:moneda], @agente.id, @fecha_de_inicio, @fecha_de_fin , "0").collect {|p| {"columna_id" => "1", "importe" => p.importe , "fila_id" => p.fila_id }}
    gastos = VGasto.partida_de_implementador_sin_proyecto(params[:moneda], @agente.id, @fecha_de_inicio, @fecha_de_fin ,"0").collect {|p| {"columna_id" => "2", "importe" => p.importe , "fila_id" => p.fila_id }}
    @datos = presupuestos + gastos 
  end

        # en agentes: selecciona la caja para sacar el informe de arqueo
  def arqueo_caja
    @listado_libros = eval( "@" + singularizar_seccion ).libro.select{|l| session[:usuario_identificado].libro.include? l}.collect {|a|[a.nombre, a.id]}
    @listado_etapa = @agente.etapa.collect{|e| [e.nombre, e.id]}
    # Si hemos especificado un libro para ver el informe
    if params[:selector] and params[:selector][:libro] != ''
      @libro = Libro.find(params[:selector][:libro])
      @columnas_nombre = [_("fecha"), _("concepto"), _("entradas"), _("salidas")]
      condiciones = { }
      if params[:selector][:etapa] != ''
        @etapa = Etapa.find(params[:selector][:etapa])
        condiciones[:fecha] = @etapa.fecha_inicio..@etapa.fecha_fin
      end
      # Obtiene todos los gastos de la cuenta en el periodo
      gastos = @libro.gasto.find :all, :conditions => condiciones
      # Obtiene todas las transferencias de la cuenta en el periodo
      #condiciones[:agente_id] = @agente.id
      transferencias = @libro.transferencia.find :all, :conditions => condiciones
      # Genera el array de gastos y transferencias para presentar
      @filas = Array.new
      transferencias.each do |transferencia|
        @filas.push(:fecha => transferencia.fecha, :concepto => _("Transferencia") + " " + _(transferencia.entrante_saliente) + ( transferencia.observaciones != '' ? ' (' + transferencia.observaciones + ')' : ''), :entrada => (transferencia.importe if transferencia.entrante_saliente=="entrante"), :salida => (transferencia.importe if transferencia.entrante_saliente!="entrante") )
      end
      gastos.each do |gasto|
        gasto.pago.each { |pago| @filas.push(:fecha => pago.fecha, :concepto => _("Pago") + " " + (gasto.concepto ? gasto.concepto : ''), :salida => pago.importe) }
        #@filas.push(:fecha => gasto.fecha, :concepto => gasto.concepto, :salida => gasto.importe)
      end
      # Ordena por fecha
      @filas.sort! { |x,y| x[:fecha] <=> y[:fecha] }
    end

    render :template => "comunes/arqueo_caja"
  end

end
