#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de las vistas resumenes de financiacion. Este controlador es utilizado desde las seccion financiación.

class ResumenFinanciacionController < ApplicationController
        # en proyectos: se redirecciona por defecto a listado_etapas
  def index
    redirect_to :action => 'presupuesto'
  end

        # en proyectos: selecciona la moneda y llama a estado_presupuesto si ya hay moneda y actividad/partida
  def presupuesto
    flash[:mensaje] = _("En esta pagina puede ver disitintos resumenes financieros del presupuesto de la financiacion") + "<BR>"
    flash[:mensaje] += _("Selecciona moneda, etapa, y tipo (por actividad o partida) de resumen.")+ "<BR>"
    flash[:mensaje] += _("NOTA-1: Si elige 'todos' en 'proyecto' el resumen se presentara agregando por proyecto.")+ "<BR>"
    flash[:mensaje] += _("NOTA-2: Recuerda aplicar tasas de cambio al presupuesto para poder ver la información.")
    @listado_proyecto = @financiacion.proyecto.collect{|e| [e.nombre, e.id]}
    @listado_proyecto << ["todos", "todos"]
    @listado_etapa = @financiacion.etapa.collect{|e| [e.nombre, e.id]}
    # Hacemos la busqueda si se seleccionan los criterios
    estado_presupuesto if params[:selector] and params[:selector][:moneda] != '' and params[:selector][:partida_actividad] != '' and params[:selector][:etapa] != ''
  end

        # en proyectos: a partir de la moneda, el tipo y la etapa prepara las variables columnas,
  # campos y condiciones, llama a Presupuesto.busqueda con esas 2 ultimas variables
  def estado_presupuesto
    @proyecto = params[:selector][:proyecto] == "todos" ? "todos" : Proyecto.find(params[:selector][:proyecto])
    @tipo = params[:selector][:partida_actividad]
    @etapa = Etapa.find(params[:selector][:etapa])
    @filas = @financiacion.partida_financiacion if @tipo == "partida"
    @filas = @proyecto.actividad if @tipo == "actividad" and @proyecto != "todos"
    @filas = (@financiacion.proyecto.collect {|p| p.actividad}).flatten if @tipo == "actividad" and @proyecto == "todos"
    @columnas, @columnas_nombre = Array.new, Array.new
    # En funcion del tipo de vista
    if @proyecto == "todos"
      for proyecto in @financiacion.proyecto
        @columnas_nombre << proyecto.nombre
        @columnas << busqueda_presupuesto(proyecto.id, "", @etapa.fecha_inicio, @etapa.fecha_fin, @tipo)
      end
    else
      for agente in @proyecto.implementador
        @columnas_nombre << agente.nombre
        @columnas << busqueda_presupuesto(@proyecto.id, agente.id, @etapa.fecha_inicio, @etapa.fecha_fin, @tipo)
      end
    end
    # Añadimos los totales como ultima columna
    @columnas_nombre << "Totales"
    totales = @filas.collect do |par|
       total = 0
       @columnas.each do |columna|
         fila = columna.detect {|p| p[:id] == par.id}
         total += fila[:importe] if fila
       end
       {:importe => total, :id => par.id}
    end
    @columnas << totales
  end

        # selecciona la moneda, los agentes
  # y llama a busqueda_presupuesto
  def gasto
    flash[:mensaje] = _("En esta pagina puede ver disitintos resumenes financieros del estado de la financiacion.") + "<BR>"
    flash[:mensaje] += _("Selecciona proyecto, agente, fechas de inicio y fin,  por actividad o partida, y el tipo de detalle.") + "<BR>"
    flash[:mensaje] += _("NOTA-1: Si se ha elaborado el presupuesto incluyendo un detalle mensual puede utilizar dicho de detalle. En caso contrario elije 'sin detalle mensual'.") + "<BR>"
    flash[:mensaje] += _("NOTA-2: Recuerda aplicar tasas de cambio al presupuesto y al gasto para poder ver la información.")
    @listado_proyecto = @financiacion.proyecto.collect{|e| [e.nombre, e.id]}
    # Hacemos la busqueda si se seleccionan los criterios
    estado_gasto if params[:selector] and params[:selector][:proyecto] != '' and params[:selector][:agente] != '' and params[:selector][:partida_actividad] != ''
  end

  def proyecto_seleccionado
    if params[:id] == ""
      render :inline => "Selecciona proyecto para seleccionar agente"
    else
      @listado_agente = Proyecto.find(params[:id]).implementador.collect{|e| [e.nombre, e.id]}
      render :inline => "  <%= selector _('Agente'), 'selector', 'agente', @listado_agente, true , '3_4'  %>"
    end
  end

        # en proyectos: a partir de la moneda, el tipo y la etapa prepara las variables columnas,
  # campos y condiciones, llama a Presupuesto.busqueda con esas 2 ultimas variables
  # llama a busqueda gasto y busqueda_transferencia
  def estado_gasto
    @agente = Agente.find(params[:selector][:agente]) if params[:selector][:agente] != ''
    @proyecto = Proyecto.find(params[:selector][:proyecto]) if params[:selector][:proyecto] != ''
    @tipo = params[:selector][:partida_actividad]
    @fecha_inicio = params[:selector][:fecha_de_inicio]
    @fecha_fin =  params[:selector][:fecha_de_fin]
    @filas = @financiacion.partida_financiacion if @tipo == "partida"
    @filas = @proyecto.actividad if @tipo == "actividad"
    # Segun la forma que se presente
    if params[:selector][:presupuesto] == "detallado"
      @presupuesto = busqueda_presupuesto_detallado @fecha_inicio, @fecha_fin, @proyecto.id, @moneda.id, (@agente ? @agente.id : nil), @tipo
    elsif params[:selector][:presupuesto] == "sin_detallado"
      @presupuesto = busqueda_presupuesto @proyecto.id, (@agente ? @agente.id : ""), @fecha_inicio, @fecha_fin, @tipo
    end
    @gasto = busqueda_gasto @proyecto.id, (@agente ? @agente.id : nil), @fecha_inicio, @fecha_fin, @tipo
    # Calculo del acumulado
    @acumulado = @filas.collect do |par|
       p = @presupuesto.detect {|p| p[:id] == par.id}
       g = @gasto.detect {|g| g[:id] == par.id}
       {:importe => (g ? g[:importe] : 0) - (p ? p[:importe] : 0), :id => par.id}
    end
    # Calculo de las trasferencias para el periodo
    @transferencia =  busqueda_transferencia @fecha_inicio, @fecha_fin, @proyecto.id, (@agente ? @agente.id : nil)
  end

        # en proyectos: llamado por estado_gasto, prepara las variables condiciones, asociaciones y agrupados
  # y llama con ellas a Presupuesto.busqueda
  def busqueda_presupuesto_detallado fecha_inicio, fecha_fin, proyecto_id, moneda_id, agente_id, tipo
    condiciones = {"presupuesto_detallado.fecha_inicio" => fecha_inicio..fecha_fin, "presupuesto_detallado.fecha_fin" => fecha_inicio..fecha_fin,
                   "presupuesto_x_proyecto.proyecto_id" => proyecto_id,  "presupuesto.moneda_id" => moneda_id }
    condiciones["presupuesto.agente_id"] = agente_id  if agente_id
    if tipo == "partida"
      campos = "sum(presupuesto_detallado.importe * presupuesto_x_proyecto.porcentaje) AS importe, presupuesto.partida_id AS id "
      asociaciones, agrupado = [:presupuesto_x_proyecto, :presupuesto_detallado], " id "
    else
      campos = "sum(presupuesto_detallado.importe * presupuesto_x_proyecto.porcentaje * presupuesto_x_actividad.porcentaje) AS importe, presupuesto_x_actividad.actividad_id AS id "
      asociaciones, agrupado = [:presupuesto_x_proyecto, :presupuesto_detallado, :presupuesto_x_actividad], " id "
      condiciones ["presupuesto_x_actividad.proyecto_id"] = @proyecto.id
    end
    return Presupuesto.busqueda(campos, condiciones, asociaciones, agrupado, nil).collect {|p| {:importe => p.importe, :id => p.id}}
  end

  def busqueda_presupuesto proyecto_id, agente_id, fecha_inicio, fecha_fin, tipo
    condiciones = {"presupuesto.fecha_inicio" => fecha_inicio..fecha_fin,
                   "presupuesto.fecha_fin" =>  fecha_inicio..fecha_fin,
                   "tasa_cambio_presupuesto.financiacion_id" => @financiacion.id}
    if @tipo == "partida"
      campos = "sum(presupuesto.importe * presupuesto_x_proyecto.porcentaje * tasa_cambio_presupuesto.tasa_cambio) AS importe, partida_financiacion.id AS id"
      asociaciones, agrupado = [:presupuesto_x_proyecto, :tasa_cambio_presupuesto, :partida_x_partida_financiacion, :partida_financiacion], " id "
    else
      campos = "sum( presupuesto_x_actividad.importe * tasa_cambio_presupuesto.tasa_cambio) AS importe, presupuesto_x_actividad.actividad_id AS id "
      asociaciones, agrupado = [:presupuesto_x_proyecto, :presupuesto_x_actividad, :tasa_cambio_presupuesto], " id "
    end
    condiciones["presupuesto.agente_id"] = agente_id if agente_id != ""
    condiciones["presupuesto_x_proyecto.proyecto_id"] = proyecto_id
    condiciones["tasa_cambio_presupuesto.proyecto_id"] = proyecto_id
    condiciones["presupuesto_x_actividad.proyecto_id"] = proyecto_id if tipo == "actividad"
    Presupuesto.busqueda(campos, condiciones, asociaciones, agrupado, nil).collect {|p| {:importe => p.importe, :id => p.id}}
  end



        # en proyectos: llamado por estado_gasto, prepara las variables condiciones, asociaciones y agrupados
  # y llama con ellas a Gsasto.busqueda
  def busqueda_gasto  proyecto_id, agente_id, fecha_inicio, fecha_fin, tipo
    condiciones = {"gasto.fecha" => fecha_inicio..fecha_fin,
                   "gasto_x_proyecto.proyecto_id" => proyecto_id,
                   "tasa_cambio_gasto.financiacion_id" => @financiacion.id}
    condiciones["libro.agente_id"] = agente_id  if agente_id
    if tipo == "partida"
      campos = "sum(gasto.importe * gasto_x_proyecto.porcentaje * tasa_cambio_gasto.tasa_cambio) AS importe, partida_financiacion.id AS id "
      asociaciones, agrupado = [:gasto_x_proyecto, :libro, :tasa_cambio_gasto , :partida_x_partida_financiacion, :partida_financiacion], " id "
    else
      campos = "sum(gasto.importe * gasto_x_proyecto.porcentaje * gasto_x_actividad.porcentaje * tasa_cambio_gasto.tasa_cambio) AS importe, gasto_x_actividad.actividad_id AS id "
      asociaciones, agrupado = [:gasto_x_proyecto, :libro, :gasto_x_actividad, :tasa_cambio_gasto ], " id "
      condiciones ["gasto_x_actividad.proyecto_id"] = proyecto_id
    end
    return Gasto.busqueda(campos, condiciones, asociaciones, agrupado, nil).collect {|g| {:importe => g.importe, :id => g.id}}
  end

        # en proyectos: llamado por estado_gasto, hace el balance de transferencias
  def busqueda_transferencia fecha_inicio, fecha_fin, proyecto_id, agente_id
    condiciones_entrante = condiciones_saliente =  {"transferencia.proyecto_id" => proyecto_id, "transferencia.fecha" => fecha_inicio..fecha_fin}
    condiciones_entrante["libro.agente_id"] = condiciones_saliente["libro.agente_id"] = agente_id if agente_id
    condiciones_entrante["entrante_saliente"] = "entrante"
    transferencia_entrante = Transferencia.sum("importe", :conditions => condiciones_entrante, :include => ["libro"])
    condiciones_saliente["entrante_saliente"] = "saliente"
    transferencia_saliente = Transferencia.sum("importe", :conditions => condiciones_saliente, :include => ["libro"])
    return transferencia_entrante - transferencia_saliente
  end

end

