#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de las vistas resumen de socio. Este controlador es utilizado desde la seccion de socios.

class ResumenSocioController < ApplicationController

  def index
    @tipo = params[:selector][:tipo] if params[:selector]
    case @tipo
      when "sexo"
        @socios = Socio.count(:id, :group => 'sexo')
      when "provincia"
        @socios = Socio.count(:id, :group => 'provincia')
      when "cuota"
        @socios = Socio.count(:id,  :group => 'tipo_cuota', :joins => "LEFT OUTER JOIN `informacion_socio` ON informacion_socio.socio_id = socio.id LEFT OUTER JOIN `tipo_cuota_socio` ON informacion_socio.tipo_cuota_socio_id = tipo_cuota_socio.id ")
      when "edad"
       @socios = Array.new
       for n in 1..10
            fecha_fin = Time.now.years_ago((n -1) * 10)
            fecha_inicio = Time.now.years_ago(n * 10)
            cantidad = Socio.count :all, :conditions => {"fecha_nacimiento" => (fecha_inicio.to_date)..(fecha_fin.to_date) }
            @socios.push [((n -1) * 10).to_s + " - " + (n * 10).to_s, cantidad]
       end
    end
  end

end
