#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++      
# metodos utilizados en las "views" de Matriz

module MatrizHelper

  # Dibuja la cabecera del cronograma.
  #   objeto => hash con :etiqueta, :fecha_inicio, :fecha_fin
  def cronograma_inicio objeto={}
   cadena = '<fieldset class="listado">'
   cadena << '<div style="min-height:200;width:970;overflow:auto;">'
   cadena << "<div class='filacabecera' style='vertical-align:middle;margin:0 auto;width:" + (200 + 27*(objeto[:duracion]+1)).to_s + "'>\n"
   cadena << '<div id="crono_etiqueta" class="elemento1">' + objeto[:etiqueta] + '</div>'

   for mes in (1..objeto[:duracion])
     cadena << '<div id="crono_mes_' + mes.to_s + '" class="elemento1_8 elemento_centrado elemento_tabla">' + mes.to_s + '</div>'
   end

   cadena << "<div class='linea'></div></div>\n"
   return cadena
  end

  # Dibuja una línea del cronograma.
  def cronograma_linea etapa, actividad
    cadena =  '<div id="crono_' + actividad.id.to_s + '" class="linea" style="margin:0 auto;width:' + (202 + 27*(etapa.meses+1)).to_s + '">'
    cadena << '<div id="crono_' + actividad.id.to_s + '_etiqueta" class="elemento1 elemento_tabla" title="' + actividad.codigo_descripcion + '">'
    cadena << truncate( actividad.codigo_descripcion, :length => ( caracteres("1") || 13 ))
    cadena << '</div>'
    for mes in (1..etapa.meses)
      seleccionado = ActividadDetallada.find_by_mes(mes, :conditions => { :etapa_id => etapa.id, :actividad_id => actividad.id}) ? true : false
      cadena << render(:partial => "mes_cronograma", :locals => { :seleccionado => seleccionado, :mes => mes, :actividad_id => actividad.id.to_s, :etapa_id => etapa.id.to_s })
    end
    #cadena << '<div class="linea"></div>'
    cadena << '</div>'
  end

  def cronograma_fin
    cadena = '<div id="spinner_cronograma" class="spinner" style="display:none" ></div></div>'
    cadena << '</fieldset>'
    return cadena 
  end

end
