#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# resultados de la matriz

class Resultado < ActiveRecord::Base
  validate :codigo_mayusculas
  validates_uniqueness_of :codigo, :scope => :proyecto_id, :message => _("Código") +   _(" repetido.")
  validates_presence_of :descripcion, :message => _("Descripción") + _(" no puede estar vacío.")

  belongs_to :proyecto
  belongs_to :objetivo_especifico
  has_many :hipotesis, :dependent => :destroy
  has_many :actividad
  has_many :indicador, :dependent => :destroy
  has_many :fuente_verificacion, :dependent => :destroy
  before_destroy :verificar_borrado

  def codigo_mayusculas
    self.codigo = self.codigo.upcase
  end

  def verificar_borrado
    errors.add( "actividad", _("hay actividades")) unless self.actividad.empty?
    errors.add_to_base( _("Un resultado tiene que estar vacio para poder ser borrado.") ) unless errors.empty?
    return false unless errors.empty?
  end
end
