#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Clases del modelo que gestiona la entidad TasaCambioGasto.
class TasaCambioGasto < ActiveRecord::Base
  untranslate_all
  validates_presence_of :tasa_cambio, :message => _("Tasa de cambio") +  _(" no puede estar vacio.")
  validates_numericality_of :tasa_cambio, :greater_than => 0, :message => _("Tasa de cambio") + _(" debe ser un numero mayor de 0.")
  validates_presence_of [:gasto_id, :proyecto_id], :message => _("Las tasa de cambio debe estar asociada a gasto y proyecto.")
  validates_uniqueness_of :gasto_id, :scope => [:proyecto_id], :message => _("El gasto ya tiene asociada tasa de cambio para el proyecto.")
end
