# Be sure to restart your server when you modify this file

# Specifies gem version of Rails to use when vendor/rails is not present
RAILS_GEM_VERSION = '2.3.5' unless defined? RAILS_GEM_VERSION
ENV['GEM_PATH'] = '/usr/lib/ruby/gems/1.8'
# Bootstrap the Rails environment, frameworks, and default configuration
require File.join(File.dirname(__FILE__), 'boot')

Rails::Initializer.run do |config|
  # Settings in config/environments/* take precedence over those specified here.
  # Application configuration should go into files in config/initializers
  # -- all .rb files in that directory are automatically loaded.

  # Add additional load paths for your own custom dirs
  # config.load_paths += %W( #{RAILS_ROOT}/extras )

  # Specify gems that this application depends on and have them installed with rake gems:install
  # config.gem "bj"
  # config.gem "hpricot", :version => '0.6', :source => "http://code.whytheluckystiff.net"
  # config.gem "sqlite3-ruby", :lib => "sqlite3"
  # config.gem "aws-s3", :lib => "aws/s3"
  #Gemas relacionadas con la internacionalizacion. Gettext para rails y el resto. Se instalan todas con gem install gettext_rails

 config.gem "tiny_mce"
 config.gem "locale"
 config.gem "locale_rails" #, :version => '2.1.0'
 config.gem "gettext"
 config.gem "spreadsheet"
 config.gem "gettext_activerecord" #, :version => '2.1.0'
 config.gem "gettext_rails" #, :version => '2.1.0'
 #config.gem 'rspec', :lib => 'spec'
 #config.gem 'rspec-rails', :lib => 'spec/rails'
 config.gem 'mislav-will_paginate', :version => '~> 2.2.3', :lib => 'will_paginate', :source => 'http://gems.github.com'
# config.gem "openrain-action_mailer_tls", :lib => 'smtp_tls', :source => 'http://gems.github.com'
 config.gem "paperclip", :version => '~> 2.3.1'

 config.gem "calendar_date_select"
 # Lo siguiente se instala via paquete, que es mas facil
 #config.gem "rmagick", :version => '2.10', :lib => "RMagick2"
 #config.gem 'action_mailer_tls', :version => '~> 1.1.3', :lib => "ActionMailer"
 #config.gem "openrain-action_mailer_tls", :lib => "smtp_tls.rb", :source => "http://gems.github.com"
  # Only load the plugins named here, in the order given (default is alphabetical).
  # :all can be used as a placeholder for all plugins not explicitly named
  # config.plugins = [ :exception_notification, :ssl_requirement, :all ]

  # Skip frameworks you're not going to use. To use Rails without a database,
  # you must remove the Active Record framework.
  # config.frameworks -= [ :active_record, :active_resource, :action_mailer ]

  # Activate observers that should always be running
  # config.active_record.observers = :cacher, :garbage_collector, :forum_observer

  # Set Time.zone default to the specified zone and make Active Record auto-convert to this zone.
  # Run "rake -D time" for a list of tasks for finding time zone names.
  config.time_zone = 'UTC'

  # The default locale is :en and all translations from config/locales/*.rb,yml are auto loaded.
  # config.i18n.load_path += Dir[Rails.root.join('my', 'locales', '*.{rb,yml}')]
  config.i18n.default_locale = :es

  #
  # Configura los paths para multisitio. Con la variable de entorno GOR_SITEID se 
  # define los paths particulares de una instancia concreta.
  # En apache se define a traves de la directiva:
  #         SetEnv GOR_SITEID "nombre_instancia"
  #
  ENV['RAILS_ETC'] ||= "/etc/gong/#{ENV['GOR_SITEID']}"
  ENV['RAILS_LOG'] ||= "/var/log/gong/#{ENV['GOR_SITEID']}"
  ENV['RAILS_VAR'] ||= ENV['GOR_SITEID']? "/var/lib/gong/#{ENV['GOR_SITEID']}/" : RAILS_ROOT + "/files/"
  ENV['RAILS_CACHE'] ||= "/var/cache/gong/#{ENV['GOR_SITEID']}"
  ENV['RAILS_TMP'] ||= ENV['GOR_SITEID']? "/tmp/gong_#{ENV['GOR_SITEID']}/" : RAILS_ROOT + "/tmp/"
  #ENV['GONG_PYTHON'] = ENV['GOR_SITEID']? "/usr/share/gong/python/" : RAILS_ROOT + "/vendor/python/" 
  ENV['GONG_PYTHON'] = "/usr/share/gong/python/"
  ENV['GONG_CM'] = ENV['GOR_SITEID']? "cm-"+ENV['GOR_SITEID'] : "cm"
  # Esto podría ir en el controlador cuadrodemando, pero lo dejamos aqui de momento para pruebas
  # para dejar el correcto (http://localhost:8180/), comentar la siguiente línea
  #ENV['GONG_CM_URL'] = 'http://desarrollo.gong.org.es:8180/'

  # Si no existe, genera el directorio temporal
  Dir.mkdir(ENV['RAILS_TMP']) unless File.directory?(ENV['RAILS_TMP'])
  # Si no existe, genera el directorio de cache
  Dir.mkdir(ENV['RAILS_CACHE']) unless File.directory?(ENV['RAILS_CACHE']) || !ENV['GOR_SITEID']

  config.database_configuration_file = ENV['RAILS_ETC'] + '.database.yml' unless !ENV['GOR_SITEID']
  config.log_path = ENV['RAILS_LOG'] + "." + ENV['RAILS_ENV'] + ".log" unless !ENV['GOR_SITEID']
  config.cache_store = :file_store, ENV['RAILS_CACHE'] unless !ENV['GOR_SITEID']

  #
  # Obtiene la version para mostrarla en el header de la pagina
  #
  File.open(RAILS_ROOT + "/changelog", "r") do |fichero|
    while (linea=fichero.gets) && ENV['GOR_VERSION'].nil?
      linea =~ /^\s*(\S+).+Version\s+(.+)$/
      ENV['GOR_VERSION'] = $2 + " (" + $1 + ")" if $1 && $2
    end
  end if File.exists?(RAILS_ROOT + "/changelog")
  ENV['GOR_VERSION'] ||= "desconocida"

end
#require "smtp_tls"
#ActionMailer::Base.raise_delivery_errors = true
#ActionMailer::Base.delivery_method = :smtp
#ActionMailer::Base.smtp_settings = {
#  :enable_starttls_auto => true
#}
CalendarDateSelect.format = :italian
 CalendarDateSelect::FORMATS[:italian] = {
# # Here's the code to pass to Date#strftime
   :date => "%m/%d/%Y",
   :time => " %I:%M %p",  # notice the space before time.  If you want date and time to be seperated with a space, put the leading space here.

   :javascript_include => "format_italian"
 }

