class ProcedureXmlSocios < ActiveRecord::Migration
  def self.up
    execute <<-__EOI
CREATE DEFINER=CURRENT_USER FUNCTION `xml_socios`() RETURNS longtext CHARSET utf8
BEGIN

DECLARE tmp longtext;

  set tmp=
  (
  SELECT  
    group_concat(
  '<socio ',
-- ID
    'id="',s.id,'" ',
-- NIF DEL DECLARADO
    'nif="',IFNULL(s.NIF,REPEAT(' ',9)),'" ',
-- NIF DEL REPRESENTANTE LEGAL DEL DECLARADO SI ES MENOR
    'nif_representante="',IFNULL(s.NIF_representante,REPEAT(' ',9)),'" ',
-- NOMBRE Y APELLIDOS DEL DECLARADO O RAZON SOCIAL SI ES UNA PERSONA JURIDICA
    'nombre="',IFNULL(s.nombre,''),'" ',
    'apellido1="',IFNULL(s.apellido1,''),'" ',
    'apellido2="',IFNULL(s.apellido2,''),'" ',
-- TRATAMIENTO
    'tratamiento="',IFNULL(s.tratamiento,''),'" ',
-- SEXO
    'sexo="',IFNULL(s.sexo,''),'" ',
-- FECHA NACIMIENTO
    'fecha_nacimiento="',IFNULL(s.fecha_nacimiento,''),'" ',
-- DIRECCION
    'direccion="',IFNULL(s.direccion,''),'" ',
-- CODIGO POSTAL
    'codigo_postal="',IFNULL(s.codigo_postal,''),'" ',
-- LOCALIDAD
    'localidad="',IFNULL(s.localidad,''),'" ',
-- MUNICIPIO
    'municipio="',IFNULL(s.municipio,''),'" ',
-- PROVINCIA
    'provincia="',IFNULL(s.provincia,''),'" ',
-- PROVINCIA PARA DEDUCCION FISCAL
    'provincia_fiscal="',IFNULL(s.codigo_provincia_fiscal,''),'" ',
-- PAIS
    'pais="',IFNULL(s.pais,''),'" ',
-- EMAIL
    'email="',IFNULL(s.email,''),'" ',
-- TELEFGONO FIJO
    'telefono_fijo="',IFNULL(s.telefono_fijo,''),'" ',
-- TELEFONO MOVIL
    'telefono_movil="',IFNULL(s.telefono_movil,''),'" ',
-- COMENTARIOS
    'comentarios="',IFNULL(s.comentarios,''),'" ',
-- FECHA ALTA
    'fecha_alta="',IFNULL(i.fecha_alta,''),'" ',
-- FECHA BAJA
    'fecha_baja="',IFNULL(i.fecha_baja,''),'" ',
-- MOTIVO BAJA
    'motivo_baja="',IFNULL(i.motivo_baja,''),'" ',
-- TIPO CUOTA ID
    'tipo_cuota_socio_id="',IFNULL(i.tipo_cuota_socio_id,''),'" ',
-- TIPO CUOTA
    'tipo_cuota_socio="',IFNULL((SELECT t.tipo_cuota FROM tipo_cuota_socio t WHERE i.tipo_cuota_socio_id=t.id),''),'" ',
-- IMPORTE CUOTA
    'importe_cuota="',IFNULL(i.importe_cuota,''),'" ',
-- CALENDARIO PAGOS
    'calendario_pagos="',IFNULL(i.calendario_pagos,''),'" ',
-- ENVIAR PERIODICA
    'enviar_periodica="',IFNULL(i.enviar_periodica,''),'" ',
-- ENVIAR PUNTUAL
    'enviar_puntual="',IFNULL(i.enviar_puntual,''),'" ',
-- ENVIAR 182
    'enviar_182="',IFNULL(i.enviar_182,''),'" ',
-- CARTA BIENVENIDA
    'fecha_carta_bienvenida="',IFNULL(i.fecha_carta_bienvenida,''),'" ',
-- ENVIO DOCUMENTAICON
    'fecha_envio_documentacion="',IFNULL(i.fecha_envio_documentacion,''),'" ',
-- ENVIO CARNE
    'fecha_envio_carne="',IFNULL(i.fecha_envio_carne,''),'" ',
-- FORMA PAGO ID
    'forma_pago_socio_id="',IFNULL(i.forma_pago_socio_id,''),'" ',
-- FORMA PAGO
    'forma_pago_socio="',IFNULL((SELECT forma_pago FROM forma_pago_socio f WHERE  f.id=i.forma_pago_socio_id),''),'" ',
-- NATURALEZA SOCIO ID
    'naturaleza_socio_id="',IFNULL(s.naturaleza_socio_id,''),'" ',
-- NATURALEZA SOCIO
    'naturaleza_socio="',IFNULL((select n.naturaleza from naturaleza_socio n WHERE n.id=s.naturaleza_socio_id),''),'" ',
-- CERRAR EL SOCIO
    ' >',
-- PAGOS
  IFNULL(xml_dame_pago_de_un_socio(s.id),''),
  '</socio>'
	SEPARATOR ''
  ) AS xml_socios

FROM
socio s, informacion_socio i
WHERE s.id=i.socio_id


);

 RETURN concat('<socios fecha_creacion="',
  CURRENT_TIMESTAMP,
  '">',
  ifnull(tmp,''),
  '</socios>');

END;
__EOI

  end

  def self.down
    execute "DROP FUNCTION IF EXISTS xml_socios"
  end
end
