class VistasSecundariasResumenes < ActiveRecord::Migration
  def self.up
  execute "DROP VIEW IF EXISTS `v_pre_act_fin_x_eta_pro_mon`"
  execute <<-EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_act_fin_x_eta_pro_mon` AS 

select
actividad_id,financiador_id,etapa_id,
proyecto_id,moneda_id_pptada as moneda_id,
sum(ppto_moneda_ppto) as importe,sum(ppto_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_x_financiador_actividad
group by
actividad_id,financiador_id,etapa_id,proyecto_id,moneda_id_pptada

EOI

  execute "DROP VIEW IF EXISTS `v_pre_act_imp_x_eta_pro_mon`"
  execute <<-EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_act_imp_x_eta_pro_mon` AS 

select
actividad_id,implementador_id,etapa_id,
proyecto_id,moneda_id_pptada as moneda_id,
sum(ppto_moneda_ppto) as importe,sum(ppto_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_x_financiador_actividad
group by
actividad_id,implementador_id,etapa_id,proyecto_id,moneda_id_pptada

EOI

  execute "DROP VIEW IF EXISTS `v_pre_det_act_fin_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_det_act_fin_x_pro_mon_fec` AS 

select 
actividad_id,financiador_id,
proyecto_id,moneda_id_pptada as moneda_id,
fecha_inicio, fecha_fin,
sum(ppto_det_moneda_ppto) as importe,sum(ppto_det_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_detallado_x_financiador_actividad
group by
actividad_id,financiador_id,proyecto_id,moneda_id_pptada,fecha_inicio, fecha_fin

EOI

  execute "DROP VIEW IF EXISTS `v_pre_det_act_imp_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_det_act_imp_x_pro_mon_fec` AS 

select 
actividad_id,implementador_id,
proyecto_id,moneda_id_pptada as moneda_id,
fecha_inicio, fecha_fin,
sum(ppto_det_moneda_ppto) as importe,sum(ppto_det_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_detallado_x_financiador_actividad
group by
actividad_id,implementador_id,proyecto_id,moneda_id_pptada,fecha_inicio, fecha_fin
EOI


  execute "DROP VIEW IF EXISTS `v_pre_det_parfin_fin_x_pro_mon_fec`"
  execute <<-EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_det_parfin_fin_x_pro_mon_fec` AS 

select 
partida_proyecto_id,financiador_id,
proyecto_id,moneda_id_pptada as moneda_id,
fecha_inicio, fecha_fin,
sum(ppto_det_moneda_ppto) as importe,sum(ppto_det_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_detallado_x_financiador_actividad
group by
partida_proyecto_id,financiador_id,proyecto_id,moneda_id_pptada,fecha_inicio, fecha_fin
EOI

  execute "DROP VIEW IF EXISTS `v_pre_det_parfin_imp_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_det_parfin_imp_x_pro_mon_fec` AS 

select 
partida_proyecto_id,implementador_id,
proyecto_id,moneda_id_pptada as moneda_id,
fecha_inicio, fecha_fin,
sum(ppto_det_moneda_ppto) as importe,sum(ppto_det_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_detallado_x_financiador_actividad
group by
partida_proyecto_id,implementador_id,proyecto_id,moneda_id_pptada,fecha_inicio, fecha_fin

EOI

  execute "DROP VIEW IF EXISTS `v_pre_det_par_fin_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_det_par_fin_x_pro_mon_fec` AS 

select 
partida_id,financiador_id,
proyecto_id,moneda_id_pptada as moneda_id,
fecha_inicio, fecha_fin,
sum(ppto_det_moneda_ppto) as importe,sum(ppto_det_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_detallado_x_financiador_actividad
group by
partida_id,financiador_id,proyecto_id,moneda_id_pptada,fecha_inicio, fecha_fin

EOI


  execute "DROP VIEW IF EXISTS `v_pre_det_par_imp_x_pro_mon_fec`"
  execute <<-EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_det_par_imp_x_pro_mon_fec` AS 

select 
partida_id,implementador_id,
proyecto_id,moneda_id_pptada as moneda_id,
fecha_inicio, fecha_fin,
sum(ppto_det_moneda_ppto) as importe,sum(ppto_det_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_detallado_x_financiador_actividad
group by
partida_id,implementador_id,proyecto_id,moneda_id_pptada,fecha_inicio, fecha_fin
EOI


  execute "DROP VIEW IF EXISTS `v_pre_parfin_fin_x_eta_pro_mon`"
  execute <<-EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_parfin_fin_x_eta_pro_mon` AS 

select
partida_proyecto_id,financiador_id,etapa_id,
proyecto_id,moneda_id_pptada as moneda_id,
sum(ppto_moneda_ppto) as importe,sum(ppto_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_x_financiador_actividad
group by
partida_proyecto_id,financiador_id,etapa_id,proyecto_id,moneda_id_pptada
EOI


  execute "DROP VIEW IF EXISTS `v_pre_parfin_imp_x_eta_pro_mon`"
  execute <<-EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_parfin_imp_x_eta_pro_mon` AS 

select 
partida_proyecto_id,implementador_id,etapa_id,
proyecto_id,moneda_id_pptada as moneda_id,
sum(ppto_moneda_ppto) as importe,sum(ppto_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_x_financiador_actividad
group by
partida_proyecto_id,implementador_id,etapa_id,proyecto_id,moneda_id_pptada
EOI


  execute "DROP VIEW IF EXISTS `v_pre_par_fin_x_eta_pro_mon`"
  execute <<-EOI  

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_par_fin_x_eta_pro_mon` AS 

select
partida_id,financiador_id,etapa_id,
proyecto_id,moneda_id_pptada as moneda_id,
sum(ppto_moneda_ppto) as importe,sum(ppto_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_x_financiador_actividad
group by
partida_id,financiador_id,etapa_id,proyecto_id,moneda_id_pptada
EOI


  execute "DROP VIEW IF EXISTS `v_pre_par_imp_x_eta_pro_mon`"
  execute <<-EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_pre_par_imp_x_eta_pro_mon` AS 

select 
partida_id,implementador_id,etapa_id,
proyecto_id,moneda_id_pptada as moneda_id,
sum(ppto_moneda_ppto) as importe,sum(ppto_moneda_base) as importe_tc 
from 
v_tablon_presupuesto_x_financiador_actividad
group by
partida_id,implementador_id,etapa_id,proyecto_id,moneda_id_pptada
EOI


  execute "DROP VIEW IF EXISTS `v_gas_act_fin_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gas_act_fin_x_pro_mon_fec` AS 

select 
actividad_id,financiador_id,
proyecto_id,moneda_id_gasto,fecha,
sum(Gasto_moneda) as importe_gasto,sum(Gasto_moneda_base) as importe_gasto_tc
from v_tablon_gastos_x_financiador_actividad
group by 
actividad_id,
financiador_id,
proyecto_id,moneda_id_gasto,fecha

EOI

  execute "DROP VIEW IF EXISTS `v_gas_act_imp_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gas_act_imp_x_pro_mon_fec` AS 

select 
actividad_id,implementador_id,
proyecto_id,moneda_id_gasto,fecha,
sum(Gasto_moneda) as importe_gasto,sum(Gasto_moneda_base) as importe_gasto_tc
from v_tablon_gastos_x_financiador_actividad
group by 
actividad_id,
implementador_id,
proyecto_id,moneda_id_gasto,fecha

EOI


  execute "DROP VIEW IF EXISTS `v_gas_parfin_fin_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gas_parfin_fin_x_pro_mon_fec` AS 


select 
partida_proyecto_id,financiador_id,
proyecto_id,moneda_id_gasto,fecha,
sum(Gasto_moneda) as importe_gasto,sum(Gasto_moneda_base) as importe_gasto_tc
from v_tablon_gastos_x_financiador_actividad
group by 
partida_proyecto_id,
financiador_id,
proyecto_id,moneda_id_gasto,fecha

EOI


  execute "DROP VIEW IF EXISTS `v_gas_parfin_imp_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gas_parfin_imp_x_pro_mon_fec` AS 

select 
partida_proyecto_id,implementador_id,
proyecto_id,moneda_id_gasto,fecha,
sum(Gasto_moneda) as importe_gasto,sum(Gasto_moneda_base) as importe_gasto_tc
from v_tablon_gastos_x_financiador_actividad
group by 
partida_proyecto_id,
implementador_id,
proyecto_id,moneda_id_gasto,fecha

EOI


  execute "DROP VIEW IF EXISTS `v_gas_par_fin_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gas_par_fin_x_pro_mon_fec` AS 


select 
partida_id,financiador_id,
proyecto_id,moneda_id_gasto,fecha,
sum(Gasto_moneda) as importe_gasto,sum(Gasto_moneda_base) as importe_gasto_tc
from v_tablon_gastos_x_financiador_actividad
group by 
partida_id,
financiador_id,
proyecto_id,moneda_id_gasto,fecha

EOI


  execute "DROP VIEW IF EXISTS `v_gas_par_imp_x_pro_mon_fec`"
  execute <<-EOI

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gas_par_imp_x_pro_mon_fec` AS 

select 
partida_id,implementador_id,
proyecto_id,moneda_id_gasto,fecha,
sum(Gasto_moneda) as importe_gasto,sum(Gasto_moneda_base) as importe_gasto_tc
from v_tablon_gastos_x_financiador_actividad
group by 
partida_id,
implementador_id,
proyecto_id,moneda_id_gasto,fecha

EOI





  end

  def self.down
  execute "DROP VIEW IF EXISTS `v_pre_act_fin_x_eta_pro_mon`"
  execute "DROP VIEW IF EXISTS `v_pre_act_imp_x_eta_pro_mon`"
  execute "DROP VIEW IF EXISTS `v_pre_det_act_fin_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_pre_det_act_imp_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_pre_det_parfin_fin_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_pre_det_parfin_imp_x_pro_mon_fec`"

  execute "DROP VIEW IF EXISTS `v_pre_det_par_fin_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_pre_det_par_imp_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_pre_parfin_fin_x_eta_pro_mon`"
  execute "DROP VIEW IF EXISTS `v_pre_parfin_imp_x_eta_pro_mon`"
  execute "DROP VIEW IF EXISTS `v_pre_par_fin_x_eta_pro_mon`"
  execute "DROP VIEW IF EXISTS `v_pre_par_imp_x_eta_pro_mon`"

  execute "DROP VIEW IF EXISTS `v_gas_act_fin_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_gas_act_imp_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_gas_parfin_fin_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_gas_parfin_imp_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_gas_par_fin_x_pro_mon_fec`"
  execute "DROP VIEW IF EXISTS `v_gas_par_imp_x_pro_mon_fec`"

  end
end
