class Workflow < ActiveRecord::Migration
  def self.up
    create_table "definicion_estado_tarea", :force => true do |t|
      t.text  "titulo"
      t.text  "descripcion"
      t.integer  "tipo_tarea_id"
      t.integer  "estado_tarea_id"
      t.integer  "definicion_estado_id"
      t.datetime "created_at"
      t.datetime "updated_at"
    end 


    create_table "definicion_estado_x_etiqueta", :force => true do |t|
      t.integer  "definicion_estado_id"
      t.integer  "etiqueta_id"
      t.datetime "created_at"
      t.datetime "updated_at"
    end 


    add_column :tarea, :fecha_prevista, :date
    add_column :tarea, :horas_empleadas, :integer
    remove_column :definicion_estado, :tipo
    remove_column :definicion_estado, :ingreso

  end

  def self.down
    drop_table "definicion_estado_tarea"
    drop_table "definicion_estado_x_etiqueta"  
    remove_column :tarea, :fecha_prevista
    remove_column :tarea, :horas_empleadas
    add_column :definicion_estado, :tipo, :text
    add_column :definicion_estado, :ingreso, :boolean
  end
end
