# This file should contain all the record creation needed to seed the database with its default values.
# The data can then be loaded with the rake db:seed (or created alongside the db with db:setup).
#
# Examples:
#   
#   cities = City.create([{ :name => 'Chicago' }, { :name => 'Copenhagen' }])
#   Major.create(:name => 'Daley', :city => cities.first)

Pais.create([{ :nombre => 'España' }]) if Pais.count == 0
Provincia.create([{ :nombre => 'Europa', :pais_id => '1' }]) if Provincia.count == 0
Comunidad.create([{ :nombre => 'Madrid', :provincia_id => '1' }]) if Comunidad.count == 0
Municipio.create([{ :nombre => 'Madrid', :comunidad_id => '1' }]) if Municipio.count == 0
TipoCuotaSocio.create([{ :tipo_cuota => 'mensual' }]) if TipoCuotaSocio.count == 0
OrigenSocio.create([{ :origen => 'otro' }]) if OrigenSocio.count == 0
FormaPagoSocio.create([{ :forma_pago => 'otro' }]) if FormaPagoSocio.count == 0 
NaturalezaSocio.create([{ :naturaleza => 'otro' }]) if NaturalezaSocio.count == 0
Usuario.create([{ :nombre => 'admin', :contrasena => Digest::SHA1.hexdigest('admin'), :correoe => 'gong@ejemplo.org', :administracion => true, :proyectos=> true, :agentes => true, :cuadromando => true, :socios => true, :documentos => true}]) if Usuario.count == 0

if DefinicionEstado.count == 0
  DefinicionEstado.create :nombre => "contacto", :tipo => "proyecto", :datos_proyecto => true, :primer_estado => true, :documento => true, :tarea => true
  DefinicionEstado.create :nombre => "identificacion", :tipo => "proyecto", :datos_proyecto => true, :tarea => true, :documento => true, :matriz => true, :estado_padre_id => DefinicionEstado.find_by_nombre("contacto").id, :primer_estado => false
  DefinicionEstado.create :nombre => "formulación", :tipo => "proyecto", :datos_proyecto => true, :tarea => true, :documento => true, :matriz => true, :presupuesto_proyectos => true, :resumen_proyecto => true, :estado_padre_id => DefinicionEstado.find_by_nombre("identificacion").id, :primer_estado => false, :partida_financiacion => true, :tasa_cambio => true, :exportacion => true, :importacion => true, :informe => true
  DefinicionEstado.create :nombre => "aprobado", :tipo => "proyecto", :datos_proyecto => true, :tarea => true, :documento => true, :matriz => true, :presupuesto_proyectos => true, :resumen_proyecto => true, :gasto_proyectos => true, :transferencia => true, :resumen_proyecto => true, :importacion => true, :exportacion => true, :estado_padre_id => DefinicionEstado.find_by_nombre("formulación").id, :primer_estado => false, :partida_financiacion => true, :tasa_cambio => true, :exportacion => true, :importacion => true, :informe => true, :transferencia => true, :gasto_proyectos => true
end
if TipoTarea.count == 0
  TipoTarea.create (:nombre =>  "Datos proyecto", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Documentacion", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Presupuesto", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Gasto", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Matriz", :tipo_proyecto => true)
end

if EstadoTarea.count == 0
  EstadoTarea.create( :nombre => "cerrada", :descripcion => "Tarea cerrada", :activo => false)
  EstadoTarea.create( :nombre => "en curso", :descripcion => "Tarea en la cual se trabaja actualmente", :activo => true)
  EstadoTarea.create( :nombre => "en espera", :descripcion => "Tarea en espera", :activo => true)
end

Moneda.create(:nombre => "Euro", :abreviatura => "EUR") if Moneda.count == 0

if Agente.count == 0
  Agente.create :nombre => "AECID", :financiador => true
  Agente.create :nombre => "ONG-INT", :financiador => true, :implementador => true
end

Proyecto.create(:nombre => "2011-GONG", :titulo => "Proyecto para la implantación en nuestra ONG de GONG", :moneda_id => Moneda.find_by_nombre("Euro").id, :agente_id => Agente.find_by_nombre("AECID").id) if Proyecto.count == 0

UsuarioXProyecto.create(:usuario_id => Usuario.find_by_nombre("admin").id, :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :rol => "moderador") if UsuarioXProyecto.count == 0

if Tarea.count == 0

  Tarea.create(:titulo => "Dar de alta etapas del proyecto", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Datos proyecto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Cambiar estado proyecto", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Datos proyecto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Dar de alta relaciones proyecto", :descripcion => "Se necesita dar de alta las entidades en administracion",:proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Datos proyecto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Dar de alta el presupuesto", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Presupuesto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Dar de alta la matriz", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Matriz").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)


end

